#pragma once

#include <string>

#include "SourceFile.h"
#include "BBParser.h"
#include "toolchain.h"

namespace build {

struct BuildConf {
	std::string outDir;
	int numJobs;
	BBParser::Variables variables;
	std::string targetName;
	std::vector<SourceFile> sources;
};

BuildConf readBuildConf(std::string outDir, int numJobs, const std::vector<std::string> &args);
bool compile(const BuildConf &conf);
void link(const BuildConf &conf, toolchain::TargetType targetType);
void writeCompileCommands(const BuildConf &conf);

}
